﻿using System.Collections;
using UnityEngine;
using UnityEditor;

[CustomEditor(typeof(FOHEART_Mocap.FoheartModelPose))]
public class FOHEART_ModelEditor : Editor 
{
    SerializedProperty skeletonObjectsField;

    public override void OnInspectorGUI()
    {
        FOHEART_Mocap.FoheartModelPose modelScript = (FOHEART_Mocap.FoheartModelPose)target;
        //default
        DrawDefaultInspector();

        if (GUILayout.Button("Auto bind skeletons"))
        {
            Debug.Log("Load transforms references into skeletons list.");
            modelScript.FindAllSkeletons();
            EditorUtility.SetDirty(modelScript);
            UnityEditor.SceneManagement.EditorSceneManager.MarkAllScenesDirty();
        }
        if (GUILayout.Button("Clear binded skeletons"))
        {
            Debug.Log("Clear all transforms references of skeletons list.");

            modelScript.ClearNameAndBone();
            EditorUtility.SetDirty(modelScript);
            UnityEditor.SceneManagement.EditorSceneManager.MarkAllScenesDirty();
        }

        serializedObject.Update();
        skeletonObjectsField = serializedObject.FindProperty("skeletonObjects");

        EditorGUI.indentLevel += 1;
        for (int i = 0; i < skeletonObjectsField.arraySize; i++)
        {
            EditorGUILayout.PropertyField(
                skeletonObjectsField.GetArrayElementAtIndex(i), 
                new GUIContent(((FOHEART_Mocap.FoheartSkeletonName.kinemHumanSkeleton53Index)i).ToString())
                );
        }
        EditorGUI.indentLevel -= 1;
        serializedObject.ApplyModifiedProperties();
    }
}

